//Packed by TDRR, but basically 99.9% of the code here is thanks to Korshun
//and also https://www.learnopengles.com/tag/per-vertex-lighting/
//so HUGE thanks to Korshun and "Kevin" (the learnopengles.com admin) for
//their fantastic work.

uniform sampler2D texture2;

vec3 getSurfaceNormal()
{
    vec3 u = dFdx(pixelpos.xyz);
    vec3 v = dFdy(pixelpos.xyz);
    vec3 normal = cross(u, v);
    return normalize(normal);
}

vec4 stf_BrightmapCalc(vec4 color, vec4 texel, vec4 brightpix)
{
	vec4 new_brightpix = desaturate(brightpix);
	return vec4(texel.rgb * min (color.rgb + new_brightpix.rgb, 1.0), texel.a*color.a);
}

vec4 Process(vec4 color)
{
	vec4 texel = getTexel(gl_TexCoord[0].st);
	vec4 brightpix = texture2D(texture2, gl_TexCoord[0].st);
	
	if(brightpix.a == 1.0)
	{
		return stf_BrightmapCalc(color,texel,brightpix);
	}
	
	vec3 lightDir = vec3(1.0, -1.0, 0.0);    
	vec3 normal = getSurfaceNormal();
	
	vec3 lightVector = lightDir;
	
	vec3 new_diffuse = vec3(max(dot(normal, lightVector), 0.1));
	
	vec3 diffuse = new_diffuse * 0.8;
	
	return vec4(texel.rgb * min(color.rgb + diffuse.rgb, 1.0), color.a);
}